<?php
/* $Id: RegAppDateUtil.php,v 1.2 2004/02/27 10:04:15 yoshi_s Exp $ */
?>
<?php
/**
 * ̾  RegAppDateUtil
 *   մϢΥ桼ƥƥ饹
 *   new ɬפʤstaticȤƻѲǽ
 */
class RegAppDateUtil
{
	/**
	 * ؿ̾make_current_date_db
	 *   ߤǡYYYY-MM-DD hh:ii:ss timezone ǳ
	 * @return string		(Date data for database)
	 */
	function make_current_date_db()
	{
		return date("Y-m-d H:i:s T");
	}

	/**
	 * ؿ̾makedate_db
	 *   ꤵ줿󤫤顢YYYY-MM-DD hh:ii:ss timezone 
	 * @param  $year	int			ǯ			(i)
	 * @param  $month	int						(i)
	 * @param  $day		int						(i)
	 * @param  $hour	int			(def=0)	(i)
	 * @param  $min		int			ʬ(def=0)	(i)
	 * @param  $sec		int			(def=0)	(i)
	 * @return string		(Date data for database)
	 */
	function makedate_db($year, $month, $day, $hour = 0, $min = 0, $sec = 0)
	{
		if ($month > 12)
		{
			$year += intval($month / 12);
			$month = $month % 12;
		}
		return sprintf("%d-%02d-%02d %02d:%02d:%02d %s", $year, $month, $day, $hour, $min, $sec, date("T"));
	}

	/**
	 * ؿ̾makedate_db_by_form
	 *   ꤵ줿yyyy/mm/ddվ󤫤顢YYYY-MM-DD hh:ii:ss timezone 
	 * @param  $date	string		ǯ(yyyy/mm/dd)			(i)
	 * @return string		(Date data for database)
	 */
	function makedate_db_by_form($date)
	{
		if (ereg("^([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})$", $date, $db_date) == FALSE)
		{
			return "";
		}
		return RegAppDateUtil::makedate_db($db_date[1], $db_date[2], $db_date[3]);
	}

	/**
	 * ؿ̾makeday_week
	 *   This function computes a day of the week from a date.
	 * @param  $year	int			ǯ			(i)
	 * @param  $month	int						(i)
	 * @param  $day		int						(i)
	 * @return int		A day of the week data
	 */
	function makeday_week($year, $month, $day)
	{
		$a = intval((12 - $month) / 10);
		$b = intval((16 * $a + 13 * $month + 8) / 5);
		$c = intval((5 * ($year - $a)) / 4);
		$e = intval(($year - $a) / 100);
		$f = intval($e / 4);
		$week = intval(($b + $c + $day - $e + $f) % 7);
		return $week;
	}

	/**
	 * ؿ̾makedate_ymd
	 *   󤫤 YEAR,MONTH,DAY 
	 * @param  $date_data	string	(the date data for database)	(i)
	 * @return string[],FALSE		[0]:year,[1]:month,[2]:day or NG
	 */
	function makedate_ymd($date_data)
	{
		$new_ymd = array();			// ̳Ǽ

		// å&ʬ
		if(ereg("^([0-9]{1,4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})(.*)$", $date_data, $ymd) == FALSE)
		{
			return FALSE;
		}
		array_shift($ymd);						// Ƭ(Delete Original Data)
		for($i = 0; $i < 3; $i++)
		{
			$new_ymd[] = array_shift($ymd);		// Extracts YMD data
		}
		return $new_ymd;
	}

	/**
	 * ؿ̾makedate_all
	 *   󤫤 YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,TIMEZONE 
	 * @param  $date_data	string	(the date data for database)	(i)
	 * @return string[],FALSE		[0]:year,[1]:month,[2]:day,[3]:hour,[4]:minute,[5]:second,[6]:t-zone or NG
	 */
	function makedate_all($date_data)
	{
		$ymdhmst = array();			// ̳Ǽ

		// å&ʬ
		if(ereg("^([0-9]{1,4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})(.*)$", $date_data, $ymdhmst) == FALSE)
		{
			return FALSE;
		}
		array_shift($ymdhmst);					// Ƭ(Delete Original Data)
		while ($ymdhmst[count($ymdhmst)-1] == "")
		{
			array_pop($ymdhmst);				//  "" 
		}
		return $ymdhmst;
	}

	/**
	 * ؿ̾check_leapyear
	 *   ꤵ줿ǯǯݤȽꤹ
	 * @param  $year	int			ǯ			(i)
	 * @return boolean	TRUE:ǯFALSE:¾
	 */
	function check_leapyear($year)
	{
		if (($year % 4 == 0) && (($year % 100 != 0) || ($year % 400 == 0)))
		{
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * ؿ̾get_day_of_month
	 *   ꤵ줿ǯη(ǯåͭ)
	 * @param  $year	int			ǯ			(i)
	 * @return int[]	112ޤǤ[0]=1...[11]=12
	 */
	function get_day_of_month($year)
	{
		$day_of_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		// ǯξ1ä
		$day_of_month[1] += RegAppDateUtil::check_leapyear($year);
		return $day_of_month;
	}

	/**
	 * ؿ̾change_day_year
	 *   ꤵ줿ǯΡǯϤηвȡǯޤǤλ
	 * @param  $year	int			ǯ			(i)
	 * @param  $month	int						(i)
	 * @param  $day		int						(i)
	 * @return int[]	[0] ǯϤηв[1] ǯޤǤλ
	 */
	function change_day_year($year, $month, $day)
	{
		$yday = array();					// ̳Ǽ
		$mday = RegAppDateUtil::get_day_of_month($year);	// 

		//--- в ---//
		for ($i = 0; $i < $month - 1; $i++)
		{
			$yday[0] += $mday[$i];			// ޤǤ
		}
		$yday[0] += $day;					// вû

		//--- ǯ ---//
		$allday = array_sum($mday);

		$yday[1] = $allday - $yday[0];		// 
		return $yday;
	}

	/**
	 * ؿ̾get_pass_day
	 *   鸽ޤǤηв
	 * @param  $date_data	string	(the date data for database)	(i)
	 * @return int	-2>λ-1եޥåȥ顼0 >= в
	 */
	function get_pass_day($date_data)
	{
		// 
		$cur_date = RegAppDateUtil::make_current_date_db();
		// ꤫鸽ߤޤǤκʬ
		return RegAppDateUtil::get_pass_day_atob($date_data , $cur_date);
	}

	/**
	 * ؿ̾get_pass_day_atob
	 *   ֤ηв
	 * @param  $date_data1	string	(the date data for database)	(i)
	 * @param  $date_data2	string	λ(the date data for database)	(i)
	 * @return int	-2>λ-1եޥåȥ顼0 >= в
	 */
	function get_pass_day_atob($date_data1, $date_data2)
	{
		//----- ENDʬ(YMD) -----//
		$endtime = RegAppDateUtil::makedate_ymd($date_data2);
		if ($endtime == FALSE)
		{
			return -1;		// եޥåȥ顼
		}
		$endYear = (int)$endtime[0];		// end Year
		$endMon  = (int)$endtime[1];		// end Month
		$endDay  = (int)$endtime[2];		// end Day
		// ENDǯ
		$endYDay = RegAppDateUtil::change_day_year($endYear, $endMon, $endDay);

		//----- STARTʬ(YMD) -----//
		$starttime = RegAppDateUtil::makedate_ymd($date_data1);
		if ($starttime == FALSE)
		{
			return -1;		// եޥåȥ顼
		}
		$startYear  = (int)$starttime[0];	// Start Year
		$startMon   = (int)$starttime[1];	// Start Month
		$startDay   = (int)$starttime[2];	// Start Day
		// STARTǯ
		$startYDay = RegAppDateUtil::change_day_year($startYear, $startMon, $startDay);

		//----- вå -----//
		$startYMD	= $starttime[0] . $starttime[1] . $starttime[2];
		$endYMD		= $endtime[0] . $endtime[1] . $endtime[2];

		if ($startYMD > $endYMD)			// STARTˤʤäƤ
		{
			return -2;		// >λ 顼
		}

		if ($endYear == $startYear)			// Ʊǯξ
		{
			$pass_day = $endYDay[0] - $startYDay[0];
		}
		else								// 㤦ǯξ
		{
			$tmpYDay = 0;
			$year_gap = $endYear - $startYear;
			for ($i = 1; $i < abs($year_gap); $i++)
			{
				// year_gap ǯ֤
				$tmp = RegAppDateUtil::get_day_of_month($startYear + $i);
				$tmpYDay += array_sum($tmp);
			}
			$pass_day = $startYDay[1] + $endYDay[0];
			$pass_day += $tmpYDay;
		}
		return $pass_day;
	}

	/**
	 * ؿ̾get_pass_hour_atob
	 *   ֤ηв֤
	 * @param  $date_data1	string	(the date data for database)	(i)
	 * @param  $date_data2	string	λ(the date data for database)	(i)
	 * @return long		-2>λ-1եޥåȥ顼0 >= в
	 */
	function get_pass_hour_atob($date_data1, $date_data2)
	{
		$passtime = RegAppDateUtil::get_pass_sec_atob($date_data1, $date_data2);
		if ($passtime < 0)
		{
			return $passtime;
		}
		$passtime = intval($passtime / 3600);
		return $passtime;
	}

	/**
	 * ؿ̾get_pass_sec_atob
	 *   ֤ηвä
	 * @param  $date_data1	string	(the date data for database)	(i)
	 * @param  $date_data2	string	λ(the date data for database)	(i)
	 * @return long		-2>λ-1եޥåȥ顼0 >= в
	 */
	function get_pass_sec_atob($date_data1, $date_data2)
	{
		//----- ENDʬ(YMD HMS T) -----//
		$endtime = RegAppDateUtil::makedate_all($date_data2);
		if ($endtime == FALSE)
		{
			return -1;		// եޥåȥ顼
		}
		$endYear = (int)$endtime[0];	// end Year
		$endMon  = (int)$endtime[1];	// end Month
		$endDay  = (int)$endtime[2];	// end Day
		$endHour = (int)$endtime[3];	// end Hour
		$endMin  = (int)$endtime[4];	// end Minute
		$endSec  = (int)$endtime[5];	// end Second
		// ENDǯ
		$endYDay = RegAppDateUtil::change_day_year($endYear, $endMon, $endDay);
		$endDSec = $endHour * 60 * 60 + $endMin * 60 + $endSec;		// ͤѴ

		//----- STARTʬ(YMD HMS T) -----//
		$starttime = RegAppDateUtil::makedate_all($date_data1);
		if($starttime == FALSE)
		{
			return -1;		// եޥåȥ顼
		}
		$startYear  = (int)$starttime[0];	// Start Year
		$startMon   = (int)$starttime[1];	// Start Month
		$startDay   = (int)$starttime[2];	// Start Day
		$startHour  = (int)$starttime[3];	// Start Hour
		$startMin   = (int)$starttime[4];	// Start Minute
		$startSec   = (int)$starttime[5];	// Start Second
		// STARTǯ
		$startYDay = RegAppDateUtil::change_day_year($startYear , $startMon , $startDay) ;
		$startDSec = $startHour * 60 * 60 + $startMin * 60 + $startSec;		// ͤѴ

		//----- вå -----//
		$startYMD = $starttime[0] . $starttime[1] . $starttime[2];
		$endYMD = $endtime[0] . $endtime[1] . $endtime[2];

		if ($startYMD > $endYMD)
		{
			return -2;		// >λ 顼
		}
		else if (($startYMD == $endYMD) && ($startDSec > $endDSec))
		{
			return -2;		// >λ 顼
		}

		$passTime = 0;
		if ($endYear == $startYear)			// Ʊǯξ
		{
			$passTime = $endYDay[0] - $startYDay[0];
		}
		else								// 㤦ǯξ
		{
			$tmpYDay = 0;
			$yearGap = $endYear - $startYear;
			for ($i = 1; $i < abs($yearGap); $i++)
			{
				// year_gap ǯ֤
				$tmp = RegAppDateUtil::get_day_of_month($startYear + $i);
				$tmpYDay += array_sum($tmp);
			}
			$passTime = $startYDay[1] + $endYDay[0];
			$passTime += $tmpYDay;
		}

		//----- вåå -----//
		if($startDSec > $endDSec)
		{
			$passTime--;
			$endDSec += 24 * 60 * 60;
		}
		$passSec = $endDSec - $startDSec;
		$passTime = $passTime * 24 * 60 * 60 + $passSec;
		return $passTime;
	}

	/**
	 * ؿ̾get_after_month
	 *   ä򻻽Ф
	 * @param  $date_data	string	(the date data for database)	(i)
	 * @param  $month		int		û								(i)
	 * @return string[],FALSE		(the date data for database) or NG
	 * @desc   ûκǽۤϺǽ˴ݤ(ex.1/30 + 1month  2/28)
	 *         ߷1򻻽(ex.4/4 + 1month  5/3)
	 */
	function get_after_month($date_data, $month)
	{
		// YMD([0]:year,[1]:month,[2]:day)
		$ymd = RegAppDateUtil::makedate_ymd($date_data);
		if ($ymd == FALSE)
		{
			return FALSE;		// եޥåȥ顼
		}

		// ꤵ줿û(12ĶĴ)
		$ymd[1] += $month;
		while ($ymd[1] > 12)
		{
			$ymd[1] -= 12;		// 12򸺻
			$ymd[0]++;			// ǯ򥤥󥯥
		}

		$ymd[2]--;				// Τϸ1(4/415/3)
		if ($ymd[2] == 0)
		{
			// 0ˤʤκǽȤ
			$ymd[1]--;
			if ($ymd[1] == 0)		// Ĵ(12ˤ1ǯ᤹)
			{
				$ymd[1] = 12;
				$ymd[0]--;
			}
			$mday = RegAppDateUtil::get_day_of_month($ymd[0]);		// 
			$ymd[2] = $mday[$ymd[1] - 1];		// Ĵǽ
		}
		else
		{
			$mday = RegAppDateUtil::get_day_of_month($ymd[0]);		// 
			if ($mday[$ymd[1] - 1] < $ymd[2])	// κǽۤˤʤ
			{
				$ymd[2] = $mday[(int)($ymd[1]-1)];		// ǽ
			}
		}
		// YMD
		$after_data = RegAppDateUtil::makedate_db($ymd[0], $ymd[1], $ymd[2]);
		return $after_data;
	}

	/**
	 * ؿ̾get_after_days
	 *   ä򻻽Ф
	 * @param  $date_data	string	(the date data for database)	(i)
	 * @param  $days		int		û								(i)
	 * @return string[],FALSE		(the date data for database) or NG
	 */
	function get_after_days($date_data, $days)
	{
		if ($days < 0)
		{
			return FALSE;
		}
		// YMD([0]:year,[1]:month,[2]:day)
		$ymd = RegAppDateUtil::makedate_ymd($date_data);
		if ($ymd == FALSE)
		{
			return FALSE;
		}
		// û
		return date("Y-m-d H:i:s T", mktime("0", "0", "0", $ymd[1], $ymd[2] + $days, $ymd[0]));
	}


	/**
	 * ؿ̾get_befor_days
	 *   դֵѤ
	 * @param  startday		int		 (YYYY-MM-DD 00:00:00 +XXXX)
	 * @param  day			int		
	 * @return timestamp	ॹס
	 *                      FALSE         DB(YYYY-MM-DD 00:00:00 +XXXX)Ǥʤ
	 */
	function get_befor_days($date_data, $days)
	{
		if ($days < 0)
		{
			return FALSE;
		}
		// YMD([0]:year,[1]:month,[2]:day)
		$ymd = RegAppDateUtil::makedate_ymd($date_data);
		if ($ymd == FALSE)
		{
			return FALSE;
		}
		// û
		return date("Y-m-d H:i:s T", mktime("0", "0", "0", $ymd[1], $ymd[2] - $days, $ymd[0]));
	}

	/**
	 * ؿ̾is_valid_date
	 *   ݤå
	 * @param  $date_data	string	(the date data for database)	(i)
	 * @return boolean		TRUEvalid dataFALSEinvalid data
	 */
	function is_valid_date($date_data)
	{
		// YMD([0]:year,[1]:month,[2]:day)
		$ymd = RegAppDateUtil::makedate_ymd($date_data);
		if ($ymd == FALSE)
		{
			return FALSE;		// եޥåȥ顼
		}

		$mday = RegAppDateUtil::get_day_of_month($ymd[0]);		// 

		// å(1-12?)
		if (((int)$ymd[1] > 12) || ((int)$ymd[1] < 1))
		{
			return FALSE;		// եޥåȥ顼
		}
		// å
		elseif (((int)$ymd[2] > $mday[(int)($ymd[1] - 1)]) || ((int)$ymd[2] < 1))
		{
			return FALSE;		// եޥåȥ顼
		}

		return TRUE;
	}

	/**
	 * ؿ̾date_cmp_yyyymmdd
	 *   YYYY/MM/DD վӤ
	 * @param  $date1		string	(YYYY/MM/DD)	(i)
	 * @param  $date2		string	λ(YYYY/MM/DD)	(i)
	 * @return int	-2եޥåȥ顼-1date1 < date20date1 == date21date1 > date2
	 */
	function date_cmp_yyyymmdd($date1, $date2)
	{
		if (ereg("^([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})$", $date1, $date_array1) == FALSE)
		{
			return -2;
		}
		if (ereg("^([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})$", $date2, $date_array2) == FALSE)
		{
			return -2;
		}

		//-----  -----//
		$YMD1 = ((int)$date_array1[1] . (int)$date_array1[2] . (int)$date_array1[3]);
		$YMD2 = ((int)$date_array2[1] . (int)$date_array2[2] . (int)$date_array2[3]);

		if (YMD1 == YMD2)
		{
			return 0;
		}
		if (YMD1 < YMD2)
		{
			return -1;
		}
		if (YMD1 > YMD2)
		{
			return 1;
		}
	}
}
?>
