<?php
/**
 * $Id: DBAPI_BASE.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
 */

/**
 * DBAPI Database API set factory class
 */
$_dbapi_profile = array();
$_dbapi_regist_flag = 0;
$_DBAPI_db = null; // DB[dsn][db] DBObjectݻ
                   //         [dsn][begin_count] begin
                   //         [dsn][begin_level] ȥ󥶥٥

class DBAPI {
  function connect($dsn = ""){
    global $_DBAPI_db;
    if ($dsn == null){
      $dsn ="";
    }
    if (!is_array($_DBAPI_db)){
      $_DBAPI_db = array();
    }
    if (!array_key_exists($dsn, $_DBAPI_db)){
      $db = new DBAPI_IMPL();
      $db->REGDB_connect($dsn);
      $db->dsn = $dsn;
      $_DBAPI_db[$dsn][db] = $db;
    }
    return $_DBAPI_db[$dsn][db];
  }
  function reset($dsn = ""){
    global $_DBAPI_db;
    if ($dsn == null){
      $dsn ="";
    }
    if (is_array($_DBAPI_db) && array_key_exists($dsn, $_DBAPI_db)){
      unset($_DBAPI_db[$dsn]);
    }
    return;
  }
  function shutdown(){
    global $_dbapi_profile;
    foreach($_dbapi_profile as $k => $v){
      $avg = $v[diff] / $v[count];
      RegV6pcLog::debug("# func={$k} cnt={$v[count]} sec={$v[diff]} avg={$avg}");
    }
    global $_DBAPI_db;
    if (is_array($_DBAPI_db)){
      foreach ($_DBAPI_db as $db){
        if ($db[begin_count] > 0){
          RegV6pcLog::err("DBAPI:ERR:func:shutdown:transaction incompleated(will be rollback) begin_count({$db[begin_count]})");
        }
      }
    }
  }
}

function DBAPI_SHUTDOWN(){
  global $_dbapi_regist_flag;
  RegV6pcLog::debug("## @ DBAPI_SHUTDOWN#{$_dbapi_regist_flag}");
  global $SCRIPT_NAME;
  RegV6pcLog::debug("# name=".$SCRIPT_NAME);
  DBAPI::shutdown();
  RegV6pcLog::debug("## DBAPI_SHUTDOWN");
}
function getmicrotime(){ 
  list($usec, $sec) = explode(" ",microtime()); 
  return ((float)$sec + (float)$usec); 
}
/**
 * DBAPI Implement Base Class
 */

class DBAPI_BASE {
  var $result;
  var $con;
  var $dsn;
  var $debug_print;
  var $debug_log;
  var $profile_log;
  /**
   *
   * @desc DBAPI_BASE󥹥ȥ饯
   */
  function DBAPI_BASE(){
    $this->debug_print = false; // ǥХåPRINT
    $this->debug_log = true;    // function call(ǥХå)
    $this->profile_log = true;  // function¹Ի¬

    global $_dbapi_regist_flag;
    if (!$_dbapi_regist_flag){
      register_shutdown_function("DBAPI_SHUTDOWN");
    }
    $_dbapi_regist_flag++;
    
    $stm = getmicrotime();

    RegV6pcLog::debug("FUNC:DBAPI_BASE:{$stm}");
  }
  function _pre_func($function_name){
    $this->tm_msec = getmicrotime();
    RegV6pcLog::debug("PREFUNC:<$function_name>:{$this->tm_msec} msec");
  }
  function _post_func($function_name){
    global $_dbapi_profile;
    $etm = getmicrotime();
    $diff_sec =  $etm - ($this->tm_msec);
    RegV6pcLog::debug("POSTFUNC:<$function_name>:{$etm} sec: diff {$diff_sec}");
    $_dbapi_profile[$function_name]['count'] = $_dbapi_profile[$function_name]['count'] + 1;
    $_dbapi_profile[$function_name]['diff'] += $diff_sec;
  }
  function _dbapi_return($function_name, $params){
    if ($this->result->is_error){
      // DB顼ȯå
      $db_error_info = $this->result->db_error_info;
      if (get_class($db_error_info) == "db_error_info"){
        $mes  = $db_error_info->error_message;
        $line = $db_error_info->line;
        $file = $db_error_info->file;
      } else {
        $mes = $db_error_info;
      }
      $func = $this->_param_string($function_name, $params);
      $errmes = "DBAPI:ERR:func:{$func}";
      $noline = "DBAPI:ERR:func:{$line},{$file}";
      $dbmes  = "DBAPI:ERR:mes:{$error_code}:'{$mes}'";
      RegV6pcLog::err($errmes);
      RegV6pcLog::err($noline);
      RegV6pcLog::err($dbmes);
      if ($this->debug_print){
        print $errmes."\n";
        print $noline."\n";
        print $dbmes."\n";
      }
      return false;
    }
    return $this->result->db_result_info;
  }
  function _param_string($func, $params){
    foreach ($params as $val){
      $msg .= $sep.$val;
      $sep = ",";
    }
    $msg = $func."($msg)";
    return $msg;
  }
  function _debug_log($func, $params){
    if ($this->debug_log){
      $msg = $this->_param_string($func, $params);
      RegV6pcLog::debug($msg);
    }
  }
  function disconnect(){
    DBAPI::reset($this->dsn); // ǡ١³
    REGDB_close($this->con);
  }
  function freeResult(){
    unset($this->result);
  }
  function begin($level = null){
    global $_DBAPI_db;
    if ($_DBAPI_db[$this->dsn][begin_count] <= 0){
      $ret = REGDB_begin($this->con, $level);
      if (!$ret){
        RegV6pcLog::err("DBAPI:ERR:func:begin($level)");
      }
      $_DBAPI_db[$this->dsn][begin_level] = $level; // ϥȥ󥶥٥ݻ
    } else {
      $ret = true;
      if ($_DBAPI_db[$this->dsn][begin_level] != $level){
        RegV6pcLog::err("DBAPI:ERR:func:begin($level):ۤʤȥ󥶥٥γ({$this->db_begin_level})ϤǤޤ");
        $ret = false;
      }
    }
    $_DBAPI_db[$this->dsn][begin_count]++;
    return $ret;
  }
  function rollback(){
    global $_DBAPI_db;
    $_DBAPI_db[$this->dsn][begin_count]--;
    if ($_DBAPI_db[$this->dsn][begin_count] < 0){
      RegV6pcLog::debug("DBAPI:ERR:func:rollback():too many rollback");
      $this->db_begin_count = 0;
      $ret = false;
    }
    // rollback
    $ret = REGDB_rollback($this->con);
    if (!$ret){
      RegV6pcLog::err("DBAPI:ERR:func:rollback()");
    }
    return $ret;
  }
  function commit(){
    global $_DBAPI_db;
    $_DBAPI_db[$this->dsn][begin_count]--;
    // begin_count1ʾΤȤϡcommitʤ
    if ($_DBAPI_db[$this->dsn][begin_count] < 0){
      RegV6pcLog::debug("DBAPI:ERR:func:commit():too many commit");
      $_DBAPI_db[$this->dsn][begin_count] = 0;
      $ret = false;
    } else if ($_DBAPI_db[$this->dsn][begin_count] == 0){
      // commit
      $ret = REGDB_commit($this->con);
      RegV6pcLog::debug("DBAPI:DEBUG:func:commit()");
      if (!$ret){
        RegV6pcLog::err("DBAPI:ERR:func:commit()");
      }
    }
    return $ret;
  }
}
?>
