<?php
//$Id: DBAPI_CIDR.php,v 1.3 2004/02/13 03:54:20 wtetsuya Exp $
require_once("mdb_common.php");
require_once("allocate.php");

class DBAPI_CIDR extends DBAPI_BASE
{
  /**
  * DBAPI_CIDR
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_CIDR($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * ؿmdb_cidr_update
  * 꿶꿳ĿǧȤ̤꿶cidr֥åƼ»ȿ˳꿶
  * @param$cidr꿶꾵ǧcidr
  * @param$updateinfoMDB_UPDATE_INFO¤
  * @param$member_number꿶Ƽ»ȿȿֹ
  * @param$date꿶(Ǥ)
  * @param$noteΡ(Ǥ)
  * @returntrueｪλ
  *          falseDB顼ȯ
  *          NO_COLUMN_SELECT(-1)SELECTʤˤǤʤä
  *          NO_RECORD_DELETE(-2)DELETEDELETEǤʤä
  *          NO_RECORD_INSERT(-3)INSERTINSERTǤʤä
  */
  function mdb_cidr_update($cidr, $updateinfo, $member_number, $date="", $note="")
  {
    if($this->profile_log)
    {
      $this->_pre_func("MDBCIDRUpdate");
    }
    $debugParam = array($cidr, $updateinfo, $member_number);
    $this->_debug_log("MDBCIDRUpdate", $debugParam);
    $this->result = MDBCIDRUpdate($this->con, $cidr, $updateinfo, $member_number, $date, $note);
    $ret = $this->_dbapi_return("MDBCIDRUpdate", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("MDBCIDRUpdate");
    }
    return $ret;
  }
  
  /**
  * ؿmdb_cidr_delete
  * 꿶ֵѤȤcidr_blockǡreturnedɥ쥹ȤֵѤ
  * @param$cidr_block꿶ֵѤcidr_block¤Τ
  * @param$updateinfoMDB_UPDATE_INFO¤
  * @returntrueｪλ
  *          falseDB顼ȯ
  *          NO_RECORD_DELETE(-2)DELETEDELETEǤʤä
  *          NO_RECORD_INSERT(-3)INSERTINSERTǤʤä
  */
  function mdb_cidr_delete($cidr_block, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("MDBCIDRDelete");
    }
    $debugParam = array($cidr_block, $updateinfo);
    $this->_debug_log("MDBCIDRDelete", $debugParam);
    $this->result = MDBCIDRDelete($this->con, $cidr_block, $updateinfo);
    $ret = $this->_dbapi_return("MDBCIDRDelete", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("MDBCIDRDelete");
    }
    return $ret;
  }
  
  /**
  * get_cidr_allocated_block
  * @desc ̥쥸ȥ꿶ƤCIDR֥å
  * @param ̥쥸ȥ̾
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_ALLOCATED_BLOCK¤(array)
  */
  function get_cidr_allocated_block($block_from, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,block_from,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetCIDRAllocatedBlock");
    }
    $debugParam = array($block_from);
    $this->_debug_log("GetCIDRAllocatedBlock", $debugParam);
    $this->result = GetCIDRAllocatedBlock($this->con, $block_from, $selcol, $ext);
    $ret = $this->_dbapi_return("GetCIDRAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetCIDRAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * get_cidr_block
  * @desc Ƽ»ȿ˳꿶äCIDR֥å
  * @param ȿά
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_BLOCK¤(array)
  */
  function get_cidr_block($member_short_name, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	      $value = "member_number";
	    }
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetCIDRBlock");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetCIDRBlock", $debugParam);
    $this->result = GetCIDRBlock($this->con, $member_short_name, $selcol, $ext);
    $ret = $this->_dbapi_return("GetCIDRBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetCIDRBlock");
    }
    return $ret;
  }
  
  /**
  * get_cidr_unallocate_block
  * @desc ƥबƤCIDR֥å
  * @param ơ(array)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_UNALLOCATE_BLOCK¤(array)
  */
  function get_cidr_unallocate_block($status_array, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	      $value = "member_number";
	    }
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,status,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetCIDRUnAllocateBlock");
    }
    $debugParam = array($status_array);
    $this->_debug_log("GetCIDRUnAllocateBlock", $debugParam);
    $this->result = GetCIDRUnAllocateBlock($this->con, $status_array, $selcol, $ext);
    $ret = $this->_dbapi_return("GetCIDRUnAllocateBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetCIDRUnAllocateBlock");
    }
    return $ret;
  }
  
  /**
  * create_cidr_allocated_block
  * @desc ̥쥸ȥ꿶ƤCIDR֥å򿷵
  * @param CIDR֥å
  * @param 꿶
  * @param ̥쥸ȥ̾
  * @param 
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function create_cidr_allocated_block($ip_network_number, $allocated_date, $block_from, $note, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("CreateCIDRAllocatedBlock");
    }
    $debugParam = array($ip_network_number, $updateinfo);
    $this->_debug_log("CreateCIDRAllocatedBlock", $debugParam);
    $this->result = CreateCIDRAllocatedBlock($this->con, $ip_network_number, $allocated_date, $block_from, $note, $updateinfo);
    $ret = $this->_dbapi_return("CreateCIDRAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateCIDRAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * create_cidr_block
  * @desc Ƽ»ȿ˳꿶äCIDR֥å򿷵
  * @param CIDR֥å
  * @param 꿶򤷤
  * @param ȿά
  * @param 
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function create_cidr_block($ip_network_number, $allocate_date, $member_short_name, $note, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("CreateCIDRBlock");
    }
    $debugParam = array($ip_network_number, $updateinfo);
    $this->_debug_log("CreateCIDRBlock", $debugParam);
    $this->result = CreateCIDRBlock($this->con, $ip_network_number, $allocate_date, $member_short_name, $note, $updateinfo);
    $ret = $this->_dbapi_return("CreateCIDRBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateCIDRBlock");
    }
    return $ret;
  }
  
  /**
  * create_cidr_unallocate_block
  * @desc ƥबƤCIDR֥å򿷵
  * @param CIDR֥å
  * @param 꿶
  * @param ȿά(̤꿶ΰΤȤnull)
  * @param ơ
  * @param 
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function create_cidr_unallocate_block($ip_network_number, $allocated_date, $member_short_name, $status, $note, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("CreateCIDRUnAllocateBlock");
    }
    $debugParam = array($ip_network_number, $updateinfo);
    $this->_debug_log("CreateCIDRUnAllocateBlock", $debugParam);
    $this->result = CreateCIDRUnAllocateBlock($this->con, $ip_network_number, $allocated_date, $member_short_name, $status, $note, $updateinfo);
    $ret = $this->_dbapi_return("CreateCIDRUnAllocateBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateCIDRUnAllocateBlock");
    }
    return $ret;
  }
  
  /**
  * save_cidr_allocated_block
  * @desc ̥쥸ȥ꿶ƤCIDR֥å򹹿
  * @param CIDR_ALLOCATED_BLOCK¤
  * @param MDB_UPDATE_INFO¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_cidr_allocated_block($block, $updateinfo, $column_array="")
  {
    $selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,block_from,note";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveCIDRAllocatedBlock");
    }
    $debugParam = array($block, $updateinfo);
    $this->_debug_log("SaveCIDRAllocatedBlock", $debugParam);
    $this->result = SaveCIDRAllocatedBlock($this->con, $block, $updateinfo, $selcol);
    $ret = $this->_dbapi_return("SaveCIDRAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveCIDRAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * save_cidr_block
  * @desc Ƽ»ȿ˳꿶äCIDR֥å򹹿
  * @param CIDR_BLOCK¤
  * @param MDB_UPDATE_INFO¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_cidr_block($block, $updateinfo, $column_array="")
  {
    $selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  		$value = "member_number";
	  	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,note";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveCIDRBlock");
    }
    $debugParam = array($block, $updateinfo);
    $this->_debug_log("SaveCIDRBlock", $debugParam);
    $this->result = SaveCIDRBlock($this->con, $block, $updateinfo, $selcol);
    $ret = $this->_dbapi_return("SaveCIDRBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveCIDRBlock");
    }
    return $ret;
  }
  
  /**
  * save_cidr_unallocate_block
  * @desc ƥबƤCIDR֥å򹹿
  * @param CIDR_UNALLOCATE_BLOCK¤
  * @param MDB_UPDATE_INFO¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_cidr_unallocate_block($block, $updateinfo, $column_array="")
  {
    $selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  		$value = "member_number";
		}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,status,note";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveCIDRUnAllocateBlock");
    }
    $debugParam = array($block, $updateinfo);
    $this->_debug_log("SaveCIDRUnAllocateBlock", $debugParam);
    $this->result = SaveCIDRUnAllocateBlock($this->con, $block, $updateinfo, $selcol);
    $ret = $this->_dbapi_return("SaveCIDRUnAllocateBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveCIDRUnAllocateBlock");
    }
    return $ret;
  }
  
  /**
  * delete_cidr_allocated_block
  * @desc ̥쥸ȥ꿶ƤCIDR֥å
  * @param CIDR֥å
  * @param MDB_UPDATE_INFO¤
  * @return ʤ
  */
  function delete_cidr_allocated_block($ip_network_number, $updateinfo)
  {
  	if($this->profile_log)
    {
      $this->_pre_func("DeleteCIDRAllocatedBlock");
    }
    $debugParam = array($ip_network_number, $updateinfo);
    $this->_debug_log("DeleteCIDRAllocatedBlock", $debugParam);
    $this->result = DeleteCIDRAllocatedBlock($this->con, $ip_network_number, $updateinfo);
    $ret = $this->_dbapi_return("DeleteCIDRAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteCIDRAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * delete_cidr_block
  * @desc Ƽ»ȿ˳꿶äCIDR֥å
  * @param CIDR֥å
  * @param MDB_UPDATE_INFO¤
  * @return ʤ
  */
  function delete_cidr_block($ip_network_number, $updateinfo)
  {
  	if($this->profile_log)
    {
      $this->_pre_func("DeleteCIDRBlock");
    }
    $debugParam = array($ip_network_number, $updateinfo);
    $this->_debug_log("DeleteCIDRBlock", $debugParam);
    $this->result = DeleteCIDRBlock($this->con, $ip_network_number, $updateinfo);
    $ret = $this->_dbapi_return("DeleteCIDRBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteCIDRBlock");
    }
    return $ret;
  }
  
  /**
  * delete_cidr_unallocate_block
  * @desc ƥबƤCIDR֥å
  * @param CIDR֥å
  * @param MDB_UPDATE_INFO¤
  * @return ʤ
  */
  function delete_cidr_unallocate_block($ip_network_number, $updateinfo)
  {
  	if($this->profile_log)
    {
      $this->_pre_func("DeleteCIDRUnAllocateBlock");
    }
    $debugParam = array($ip_network_number, $updateinfo);
    $this->_debug_log("DeleteCIDRUnAllocateBlock", $debugParam);
    $this->result = DeleteCIDRUnAllocateBlock($this->con, $ip_network_number, $updateinfo);
    $ret = $this->_dbapi_return("DeleteCIDRUnAllocateBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteCIDRUnAllocateBlock");
    }
    return $ret;
  }
  
  /**
  * select_cidr_allocated_block_history
  * @desc ̥쥸ȥ꿶ƤCIDR֥åι
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_ALLOCATED_BLOCK_HISTORY¤(array)
  */
  function select_cidr_allocated_block_history($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,block_from,note,update_person,update_date,accept_id,operation_id";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectCIDRAllocatedBlockHistory");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectCIDRAllocatedBlockHistory", $debugParam);
    $this->result = SelectCIDRAllocatedBlockHistory($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectCIDRAllocatedBlockHistory", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectCIDRAllocatedBlockHistory");
    }
    return $ret;
  }
  
  /**
  * select_cidr_allocated_block_history_update_date
  * @desc ̥쥸ȥ꿶ƤCIDR֥åι
  * @param 
  * @param λ
  * @return CIDR֥å(array)
  */
  function select_cidr_allocated_block_history_update_date($start, $end=null)
  {
    if($this->profile_log)
    {
      $this->_pre_func("SelectCIDRAllocatedBlockHistoryByUpdateDate");
        }
    $debugParam = array($start, $end);
        $this->_debug_log("SelectCIDRAllocatedBlockHistoryByUpdateDate", $debugParam);
        $this->result = SelectCIDRAllocatedBlockHistoryByUpdateDate($this->con, $start, $end);
        $ret = $this->_dbapi_return("SelectCIDRAllocatedBlockHistoryByUpdateDate", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("SelectCIDRAllocatedBlockHistoryByUpdateDate");
        }
    return $ret;
  }
  
  /**
  * select_cidr_block_history
  * @desc Ƽ»ȿ˳꿶äCIDR֥åι
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_BLOCK_UPDATE_HISTORY¤(array)
  */
  function select_cidr_block_history($ip_network_number, $column_array="", $limit="", $offset="")
  {
  	$selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,note,update_person,update_date,accept_id,operation_id";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludedCIDRBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectCIDRBlockHistory", $debugParam);
    $this->result = SelectCIDRBlockHistory($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectCIDRBlockHistory", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectCIDRBlockHistory");
    }
    return $ret;
  }
  
  /**
  * select_cidr_block_history_update_date
  * @desc Ƽ»ȿ˳꿶äCIDR֥åι
  * @param 
  * @param λ
  * @return CIDR֥å(array)
  */
  function select_cidr_block_history_update_date($start, $end=null)
  {
  	if($this->profile_log)
    {
      $this->_pre_func("SelectCIDRBlockHistoryByUpdateDate");
        }
    $debugParam = array($start, $end);
        $this->_debug_log("SelectCIDRBlockHistoryByUpdateDate", $debugParam);
        $this->result = SelectCIDRBlockHistoryByUpdateDate($this->con, $start, $end);
        $ret = $this->_dbapi_return("SelectCIDRBlockHistoryByUpdateDate", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("SelectCIDRBlockHistoryByUpdateDate");
        }
    return $ret;
  }
  
  /**
  * select_cidr_unallocate_block_history
  * @desc ƥबƤCIDR֥åι
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_UNALLOCATE_BLOCK_HISTORY¤(array)
  */
  function select_cidr_unallocate_block_history($ip_network_number, $column_array="", $limit="", $offset="")
  {
  	$selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,status,note,update_person,update_date,accept_id,operation_id";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectCIDRUnAllocateBlockHistory");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectCIDRUnAllocateBlockHistory", $debugParam);
    $this->result = SelectCIDRUnAllocateBlockHistory($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectCIDRUnAllocateBlockHistory", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectCIDRUnAllocateBlockHistory");
    }
    return $ret;
  }
  
  /**
  * select_cidr_unallocate_block_history_update_date
  * @desc ƥबƤCIDR֥åι
  * @param 
  * @param λ
  * @return CIDR֥å(array)
  */
  function select_cidr_unallocate_block_history_update_date($start, $end=null)
  {
  	if($this->profile_log)
    {
      $this->_pre_func("SelectCIDRUnAllocateBlockHistoryByUpdateDate");
        }
    $debugParam = array($start, $end);
        $this->_debug_log("SelectCIDRUnAllocateBlockHistoryByUpdateDate", $debugParam);
        $this->result = SelectCIDRUnAllocateBlockHistoryByUpdateDate($this->con, $start, $end);
        $ret = $this->_dbapi_return("SelectCIDRUnAllocateBlockHistoryByUpdateDate", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("SelectCIDRUnAllocateBlockHistoryByUpdateDate");
        }
    return $ret;
  }
  
  /**
  * select_included_cidr_allocated_block
  * @desc CIDR֥å˴ޤޤCIDR_ALLOCATED_BLOCK¤Τξ
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_ALLOCATED_BLOCK¤(array)
  */
  function select_included_cidr_allocated_block($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,block_from,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludedCIDRAllocatedBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludedCIDRAllocatedBlock", $debugParam);
    $this->result = SelectIncludedCIDRAllocatedBlock($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludedCIDRAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludedCIDRAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * select_include_cidr_allocated_block
  * @desc CIDR֥åޤCIDR_ALLOCATED_BLOCK¤Τξ
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_ALLOCATED_BLOCK¤(array)
  */
  function select_include_cidr_allocated_block($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,block_from,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludeCIDRAllocatedBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludeCIDRAllocatedBlock", $debugParam);
    $this->result = SelectIncludeCIDRAllocatedBlock($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludeCIDRAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludeCIDRAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * select_included_cidr_block
  * @desc CIDR֥å˴ޤޤCIDR_BLOCK¤Τξ
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_BLOCK¤(array)
  */
  function select_included_cidr_block($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludedCIDRBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludedCIDRBlock", $debugParam);
    $this->result = SelectIncludedCIDRBlock($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludedCIDRBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludedCIDRBlock");
    }
    return $ret;
  }
  
  /**
  * select_include_cidr_block
  * @desc CIDR֥åޤCIDR_BLOCK¤Τξ
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_BLOCK¤(array)
  */
  function select_include_cidr_block($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludeCIDRBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludeCIDRBlock", $debugParam);
    $this->result = SelectIncludeCIDRBlock($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludeCIDRBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludeCIDRBlock");
    }
    return $ret;
  }
  
  /**
  * select_included_cidr_unallocate_block
  * @desc CIDR֥å˴ޤޤCIDR_UNALLOCATE_BLOCK¤Τξ
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_UNALLOCATE_BLOCK¤(array)
  */
  function select_included_cidr_unallocate_block($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,status,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludedCIDRUnAllocateBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludedCIDRUnAllocateBlock", $debugParam);
    $this->result = SelectIncludedCIDRUnAllocateBlock($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludedCIDRUnAllocateBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludedCIDRUnAllocateBlock");
    }
    return $ret;
  }
  
  /**
  * select_include_cidr_unallocate_block
  * @desc CIDR֥åޤCIDR_UNALLOCATE_BLOCK¤Τξ
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_UNALLOCATE_BLOCK¤(array)
  */
  function select_include_cidr_unallocate_block($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,status,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludeCIDRUnAllocateBlock");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludeCIDRUnAllocateBlock", $debugParam);
    $this->result = SelectIncludeCIDRUnAllocateBlock($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludeCIDRUnAllocateBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludeCIDRUnAllocateBlock");
    }
    return $ret;
  }
  
  /**
  * get_cidr_block_none_dns
  * @desc ȿάΤ˳꿶ƤCIDR֥åΤհDNSꤵƤʤΤ
  * @param ȿά
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return CIDR_BLOCK¤
  */
  function get_cidr_block_none_dns($member_short_name, $column_array="", $limit="", $offset="")
  {
  	$selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "member_short_name"){
	  $value = "member_number";
	}
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,prefix_length,initial_registration_date,last_update_date,member_number,note";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetCIDRBlockNoneDNS");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetCIDRBlockNoneDNS", $debugParam);
    $this->result = GetCIDRBlockNoneDNS($this->con, $member_short_name, $selcol, $ext);
    $ret = $this->_dbapi_return("GetCIDRBlockNoneDNS", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetCIDRBlockNoneDNS");
    }
    return $ret;
  }
  
  /**
  * get_sdb_allocated_block
  * @desc ˤҤĤƤCIDR֥å
  * @param $accept_id No
  * @retrun CIDR֥åꥹ
  */
  function get_sdb_allocated_block($accept_id)
  {
    if($this->profile_log)
    {
      $this->_pre_func("GetSDBAllocatedBlock");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("GetSDBAllocatedBlock", $debugParam);
    $this->result = GetSDBAllocatedBlock($this->con, $accept_id);
    $ret = $this->_dbapi_return("GetSDBAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetSDBAllocatedBlock");
    }
    return $ret;
  }
  
  /**
  * create_sdb_allocated_block
  * @desc CIDR֥åҤĤ
  * @param $accept_id No
  * @param $ip_network_number(array) ҤĤCIDR֥åꥹ
  * @return Կԡfalse
  */
  function create_sdb_allocated_block($accept_id, $addr_list)
  {
    if($this->profile_log)
    {
      $this->_pre_func("CreateSDBAllocatedBlock");
    }
    $debugParam = array($accept_id, $addr_list);
    $this->_debug_log("CreateSDBAllocatedBlock", $debugParam);
    $this->result = CreateSDBAllocatedBlock($this->con, $accept_id, $addr_list);
    $ret = $this->_dbapi_return("CreateSDBAllocatedBlock", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateSDBAllocatedBlock");
    }
    return $ret;
  }
}

?>
