/**
 * v6pctool_indexes.sql
 * $Id: v6pctool_indexes.sql,v 1.6 2004/02/23 01:36:37 yoshi_s Exp $
 */

-------------------------------------------------------------------------------
-- mdb
-------------------------------------------------------------------------------

--
-- cidr_allocated_block_idx
--

CREATE INDEX cidr_allocated_block_idx ON cidr_allocated_block (start_sequence_number, end_sequence_number);

--
-- cidr_allocated_block_history
--

CREATE INDEX cidr_allocated_block_history_idx ON cidr_allocated_block_history (ip_network_number, update_date);
CREATE INDEX cidr_allocated_block_history_idx2 ON cidr_allocated_block_history (update_date);

--
-- cidr_block
--

CREATE INDEX cidr_block_idx ON cidr_block (start_sequence_number, end_sequence_number);

--
-- cidr_block_update_history
--

CREATE INDEX cidr_block_update_history_idx ON cidr_block_update_history (ip_network_number, update_date);
CREATE INDEX cidr_block_update_history_idx2 ON cidr_block_update_history (update_date);

--
-- cidr_unallocate_block
--

CREATE INDEX cidr_unallocate_block_idx ON cidr_unallocate_block (start_sequence_number, end_sequence_number);

--
-- cidr_unallocate_block_history
--

CREATE INDEX cidr_unallocate_block_history_idx ON cidr_unallocate_block_history (ip_network_number, update_date);
CREATE INDEX cidr_unallocate_block_history_idx2 ON cidr_unallocate_block_history (update_date);

--
-- mdb_ipnetinfo
--

CREATE INDEX mdb_ipnetinfo_idx ON mdb_ipnetinfo (cidr_block);
CREATE INDEX mdb_ipnetinfo_idx2 ON mdb_ipnetinfo (start_sequence_number, end_sequence_number);

--
-- mdb_ipnet_technical_resp
--

CREATE INDEX mdb_ipnet_technical_resp_jdx ON mdb_ipnet_technical_resp (ip_network_number);

--
-- mdb_ipnet_mail_address
--

CREATE INDEX mdb_ipnet_mail_address_idx ON mdb_ipnet_mail_address (ip_network_number);

--
-- mdb_ipnet_update_history
--

CREATE INDEX mdb_ipnet_update_history_idx ON mdb_ipnet_update_history (ip_network_number, update_date);
CREATE INDEX mdb_ipnet_update_history_idx2 ON mdb_ipnet_update_history (update_date);

--
-- mdb_mem_update_history
--

CREATE INDEX mdb_mem_update_history_idx ON mdb_mem_update_history (member_number, update_date);
CREATE INDEX mdb_mem_update_history_idx2 ON mdb_mem_update_history (update_date);

--
-- mdb_dnsinfo
--

CREATE INDEX mdb_dnsinfo_idx ON mdb_dnsinfo (start_sequence_number, end_sequence_number);

--
-- mdb_dns_update_history
--

CREATE INDEX mdb_dns_update_history_idx ON mdb_dns_update_history (ip_network_number, update_date);
CREATE INDEX mdb_dns_update_history_idx2 ON mdb_dns_update_history (update_date);


-------------------------------------------------------------------------------
-- rdb
-------------------------------------------------------------------------------

--
-- rdb_admin_c
--

CREATE INDEX rdb_admin_c_idx ON rdb_admin_c (report_id);

--
-- rdb_tech_c
--

CREATE INDEX rdb_tech_c_idx ON rdb_tech_c (report_id);

--
-- rdb_rev_srv
--

CREATE INDEX rdb_rev_srv_idx ON rdb_rev_srv (report_id);

--
-- rdb_remarks
--

CREATE INDEX rdb_remarks_idx ON rdb_remarks (report_id);

--
-- rdb_notify
--

CREATE INDEX rdb_notify_idx ON rdb_notify (report_id);

--
-- rdb_mnt_by
--

CREATE INDEX rdb_mnt_by_idx ON rdb_mnt_by (report_id);

--
-- rdb_mnt_lower
--

CREATE INDEX rdb_mnt_lower_idx ON rdb_mnt_lower (report_id);

--
-- rdb_mnt_irt
--

CREATE INDEX rdb_mnt_irt_idx ON rdb_mnt_irt (report_id);

--
-- rdb_changed
--

CREATE INDEX rdb_changed_idx ON rdb_changed (report_id);

