<?php
/**
 * $Id: RegIPrevUpdate.php,v 1.1 2004/03/08 13:25:40 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegIPrevMsg.php");			// DNSžå
require_once("RegIPrevConf.php");			// config饹

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
// оݥ
define("UPDATE_CONF_FILE", 0);					// conf(.conf)
define("UPDATE_ZONE_FILE", 1);					// zone(.rev)

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegIPrevUpdate
{
	//----- å -----//
	/**
	 * åꥹ
	 */
	var $m_iprev_msg;

	/**
	 * åϿʸ
	 */
	var $m_log_msg;

	/**
	 * debugåϿʸ
	 */
	var $m_debug_msg;

	/**
	 * debug ե饰
	 */
	var $m_debug_flag;

	//----- ǡ -----//
	/**
	 * iniեǡ(RegIPrevConf֥)
	 */
	var $m_iprev_conf;

	//----- ޥʸ -----//
	/**
	 * diffޥ
	 */
	var $m_cmd_diff;

	/**
	 * cpޥ
	 */
	var $m_cmd_cp_all;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegIPrevUpdate
	 *   RegIPrevUpdate饹󥹥ȥ饯
	 * @param  $iprev_conf   RegIPrevConf֥   (i)
	 * @param  $iprev_msg    åꥹ           (i)
	 * @param  $debug_flag   ǥХåե饰(def=FALSE)  (i)
	 */
	function RegIPrevUpdate($iprev_conf, $iprev_msg, $debug_flag=FALSE)
	{
		$this->m_iprev_conf	= $iprev_conf;		// iniե
		$this->m_iprev_msg	= $iprev_msg;		// inc0103ѥåꥹ
		$this->m_log_msg	= "";				// å
		$this->m_debug_msg	= "";				// ǥХåå
		$this->m_debug_flag	= $debug_flag;		// ǥХåե饰

		$this->init_cmd_str();					// ޥʸ
	}

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾update_conf_file
	 *   confեιå
	 *         ɲåե ȿǤ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN73	CURCONF
	 *               IPREV_GEN74	DELCONF
	 *               IPREV_GEN75	CURCONFdelete
	 *               IPREV_GEN77	NEWCONFcopy
	 *               IPREV_GEN79	diff command 
	 *               IPREV_GEN82	NEWCONF all copy
	 *               IPREV_GEN99	fatal error
	 * @desc   NEWCONF  CURCONF Ӥ֤˱Ʋ
	 *         Ԥ
	 *            CURCONF ˥ԡ
	 *            CURCONF ˾񤭥ԡ
	 *            CURCONF  DELCONF ˰ư
	 *            Ʊ⤷ʤ
	 *         NEWCONF ¸ߤʤ CURCONF ƺ
	 *         NEWCONF & CURCONF ¸ߤʤϲ⤷ʤ
	 */
	function update_conf_file()
	{
		$result = $this->update_dns_file(UPDATE_CONF_FILE);
		switch ($result)
		{
		case IPREV_GEN00:		// 
		case IPREV_GEN73:		// CURCONF
		case IPREV_GEN74:		// DELCONF
		case IPREV_GEN75:		// CURCONFdelete
		case IPREV_GEN77:		// NEWCONFcopy
		case IPREV_GEN79:		// diff command 
		case IPREV_GEN82:		// NEWCONF all copy
			break;
		case IPREV_GEN99:		// fatal error
		default:
			$this->set_log_msg(IPREV_GEN99, "");
			$result = IPREV_GEN99;
		}

		return $result;
	}

	/**
	 * ؿ̾update_zone_file
	 *   zoneեιå
	 *         ɲåե ȿǤ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN73	CURZONE
	 *               IPREV_GEN74	DELZONE
	 *               IPREV_GEN75	CURZONEdelete
	 *               IPREV_GEN77	NEWZONEcopy
	 *               IPREV_GEN79	diff command 
	 *               IPREV_GEN82	NEWZONE all copy
	 *               IPREV_GEN99	fatal error
	 * @desc   NEWZONE  CURZONE Ӥ֤˱Ʋ
	 *         Ԥ
	 *            CURZONE ˥ԡ
	 *            CURZONE ˾񤭥ԡ
	 *            CURZONE  DELZONE ˰ư
	 *            Ʊ⤷ʤ
	 *         NEWZONE ¸ߤʤ CURZONE ƺ
	 *         NEWZONE & CURZONE ¸ߤʤϲ⤷ʤ
	 */
	function update_zone_file()
	{
		$result = $this->update_dns_file(UPDATE_ZONE_FILE);
		switch ($result)
		{
		case IPREV_GEN00:		// 
		case IPREV_GEN73:		// CURZONE
		case IPREV_GEN74:		// DELZONE
		case IPREV_GEN75:		// CURZONEdelete
		case IPREV_GEN77:		// NEWZONEcopy
		case IPREV_GEN79:		// diff command 
		case IPREV_GEN82:		// NEWZONE all copy
			break;
		case IPREV_GEN99:		// fatal error
		default:
			$this->set_log_msg(IPREV_GEN99, "");
			$result = IPREV_GEN99;
		}

		return $result;
	}


	//-----------------------------------------------------------------------
	// private methodsʥե빹
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾update_dns_file
	 *   conf/zoneեιå
	 *         ɲåե ȿǤ
	 * @param  $type    оݥ
	 *                  UPDATE_CONF_FILE or UPDATE_ZONE_FILE
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN73	CUR[ZONE|CONF]
	 *               IPREV_GEN74	DEL[ZONE|CONF]
	 *               IPREV_GEN75	CUR[ZONE|CONF]delete
	 *               IPREV_GEN77	NEW[ZONE|CONF]copy
	 *               IPREV_GEN79	diff command 
	 *               IPREV_GEN82	NEW[ZONE|CONF] all copy
	 *               IPREV_GEN99	fatal error
	 * @desc   NEW[ZONE|CONF]  CUR[ZONE|CONF] Ӥ֤˱Ʋ
	 *         Ԥ
	 *            CUR[ZONE|CONF] ˥ԡ
	 *            CUR[ZONE|CONF] ˾񤭥ԡ
	 *            CUR[ZONE|CONF]  DEL[ZONE|CONF] ˰ư
	 *            Ʊ⤷ʤ
	 *         NEW[ZONE|CONF] ¸ߤʤ CUR[ZONE|CONF] ƺ
	 *         NEW[ZONE|CONF] & CUR[ZONE|CONF] ¸ߤʤϲ⤷ʤ
	 */
	function update_dns_file($type)
	{
		//-------------------------------------------------------------------
		// Ƚ
		//-------------------------------------------------------------------
		$conf_data = $this->m_iprev_conf->m_conf_data;
		switch ($type)
		{
		case UPDATE_CONF_FILE:
			$new_dir = $conf_data[NEWCONF];		// confǥ쥯ȥ
			$cur_dir = $conf_data[CURCONF];		// confǥ쥯ȥ
			$del_dir = $conf_data[DELCONF];		// confǥ쥯ȥ
			break;

		case UPDATE_ZONE_FILE:
			$new_dir = $conf_data[NEWZONE];		// zoneǥ쥯ȥ
			$cur_dir = $conf_data[CURZONE];		// zoneǥ쥯ȥ
			$del_dir = $conf_data[DELZONE];		// zoneǥ쥯ȥ
			break;

		default:
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		if ($new_dir == "" || $cur_dir == "" || $del_dir == "")
		{
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		//-------------------------------------------------------------------
		// ǥ쥯ȥåץ
		//-------------------------------------------------------------------
		$ndh		= FALSE;			// NEW[ZONE|CONF] dirϥɥ
		$cdh		= FALSE;			// CUR[ZONE|CONF] dirϥɥ
		$ddh		= FALSE;			// DEL[ZONE|CONF] dirϥɥ
		$new_exist	= TRUE;				// newե饰
		$cur_exist	= TRUE;				// currentե饰
		$cur_create	= FALSE;			// currentե饰
		//----- NEW[ZONE|CONF] -----//
		$ndh = opendir($new_dir);
		if ($ndh == FALSE)
		{
			$this->set_log_msg(IPREV_GEN70, array($new_dir));
			$new_exist = FALSE;			// new ʤ
		}
		//----- CUR[ZONE|CONF] -----//
		$cdh = opendir($cur_dir);
		if ($cdh == FALSE)
		{
			$this->set_log_msg(IPREV_GEN72, array($cur_dir));

			// NEW[ZONE|CONF] ¸ߤʤƤ rsync Ѥ˺
			if (mkdir($cur_dir, 0755) == FALSE)
			{
				$this->close_all_dir($ndh, $cdh);
				$this->set_log_msg(IPREV_GEN73, array($cur_dir));
				return IPREV_GEN73;
			}

			$this->set_log_msg(IPREV_GEN71, array($cur_dir));

			// NEW[ZONE|CONF] ¸ߤԡΤopen
			if ($new_exist)
			{
				$cdh = opendir($cur_dir);
				if ($cdh == FALSE)				// ǰΤ
				{
					$this->close_all_dir($ndh, $cdh);
					$this->set_log_msg(IPREV_GEN73, array($cur_dir));
					return IPREV_GEN73;
				}
				$cur_create	= TRUE;				// current
			}
			// NEW[ZONE|CONF] ¸ߤʤcurrentʤ
			else
			{
				$cur_exist	= FALSE;	// currentʤե饰
			}
		}
		//----- DEL[ZONE|CONF] -----//
		if ($cur_exist && $cur_create == FALSE)
		{
			// CUR ¸ߤΤߥå
			$ddh = opendir($del_dir);
			if ($ddh == FALSE)
			{
				if (mkdir($del_dir, 0755) == FALSE)
				{
					$this->close_all_dir($ndh, $cdh);
					$this->set_log_msg(IPREV_GEN74, array($del_dir));
					return IPREV_GEN74;
				}
			}
			else
			{
				closedir($ddh);
			}
		}

		//-------------------------------------------------------------------
		// ե륢åץǡ
		//-------------------------------------------------------------------
		// CUR[ZONE|CONF] ¸ߤʤ
		if ($cur_exist == FALSE)
		{
			// CUR¸ߤʤѥNEW¸ߤʤΤ
			$this->set_debug_msg(IPREV_GEN84, array($new_dir, $cur_dir));
		}
		// CUR[ZONE|CONF] 򿷵
		else if ($cur_create == TRUE)
		{
			// CUR򿷵ѥǤNEWԡ
			$cmd_str = sprintf("%s %s/ %s", $this->m_cmd_cp_all, $new_dir, $cur_dir);
			$cmd_ret = 1;
			system($cmd_str, $cmd_ret);
			if ($cmd_ret != 0)
			{
				$this->close_all_dir($ndh, $cdh);
				$this->set_log_msg(IPREV_GEN82, array($new_dir, ("ret:" . $cmd_ret)));
				return IPREV_GEN82;
			}
			$this->set_log_msg(IPREV_GEN83, array($new_dir));
		}
		else
		{
			// NEW&CUR¸ߡCURΤ¸ߡΣѥϺå
			//----- եǧ -----//
			while (FALSE !== ($cur_entry = readdir($cdh)))
			{
				$result = $this->update_dns_file_del($cur_entry,
													 $cur_dir,
													 $new_dir,
													 $del_dir);
				switch ($result)
				{
				case IPREV_GEN00:
					break;
				case IPREV_GEN75:			// CUR[ZONE|CONF]delete
					$this->close_all_dir($ndh, $cdh);
					return $result;
				default:
					$this->close_all_dir($ndh, $cdh);
					return IPREV_GEN99;
				}
			}

			// NEW&CUR¸ߡΥѥΤɲáå
			if ($new_exist)
			{
				//----- ɲáեǧ -----//
				while (FALSE !== ($new_entry = readdir($ndh)))
				{
					$result = $this->update_dns_file_up($new_entry,
														$cur_dir,
														$new_dir);
					switch ($result)
					{
					case IPREV_GEN00:
						break;
					case IPREV_GEN77:			// NEW[ZONE|CONF]copy
					case IPREV_GEN79:			// diff command 
					case IPREV_GEN99:			// fatal error
						$this->close_all_dir($ndh, $cdh);
						return $result;
					default:
						$this->close_all_dir($ndh, $cdh);
						return IPREV_GEN99;
					}
				}
			}
		}

		$this->close_all_dir($ndh, $cdh);
		return IPREV_GEN00;
	}

	/**
	 * ؿ̾update_dns_file_del
	 *   conf/zoneեκåоݥե
	 *          rename 
	 * @param  $file_name		åоݤΥե̾	(i)
	 * @param  $cur_dir			CUR[ZONE|CONF]				(i)
	 * @param  $new_dir			NEW[ZONE|CONF]				(i)
	 * @param  $del_dir			DEL[ZONE|CONF]				(i)
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN75	CUR[ZONE|CONF]delete
	 * @desc   CUR[ZONE|CONF]/$file_name  NEW[ZONE|CONF]/$file_name Ȥ
	 *         Ӥ֤˱ƲԤ
	 *            CUR[ZONE|CONF]  DEL[ZONE|CONF] rename
	 *         åоݤ CUR[ZONE|CONF]/$file_name եʳξ
	 *         ϽԤ鷺 IPREV_GEN00 ֤
	 */
	function update_dns_file_del($file_name, $cur_dir, $new_dir, $del_dir)
	{
		$cur_path = $cur_dir . "/" . $file_name;
		if (is_file($cur_path))
		{
			$new_path = $new_dir . "/" . $file_name;
			// $new_dir ¸ߤʤкоݤȤ $del_dir ˰ư
			if (file_exists($new_path) == FALSE)
			{
				$del_path = $del_dir . "/" . $file_name;
				if (rename($cur_path, $del_path))
				{
					$this->set_log_msg(IPREV_GEN76, array($file_name));
//					$this->set_debug_msg(IPREV_GEN76, array($file_name));
				}
				else
				{
					$this->set_log_msg(IPREV_GEN75, array($file_name));
					return IPREV_GEN75;
				}
			}
		}
		return IPREV_GEN00;
	}

	/**
	 * ؿ̾update_dns_file_up
	 *   conf/zoneեɲáåɲо
	 *         ե copy оݥե  copy 
	 * @param  $file_name		åоݤΥե̾	(i)
	 * @param  $cur_dir			CUR[ZONE|CONF]				(i)
	 * @param  $new_dir			NEW[ZONE|CONF]				(i)
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN77	NEW[ZONE|CONF]copy
	 *               IPREV_GEN79	diff command 
	 *               IPREV_GEN99	fatal error
	 * @desc   NEW[ZONE|CONF]/$file_name  CUR[ZONE|CONF]/$file_name Ȥ
	 *         Ӥ֤˱ƲԤ
	 *            CUR[ZONE|CONF] ˥ԡ
	 *            CUR[ZONE|CONF] ˾񤭥ԡ
	 *            Ʊ⤷ʤ
	 *         åоݤ CUR[ZONE|CONF]/$file_name եʳξ
	 *         ϽԤ鷺 IPREV_GEN00 ֤
	 */
	function update_dns_file_up($file_name, $cur_dir, $new_dir)
	{
		$df_result	= FALSE;
		$new_path	= $new_dir . "/" . $file_name;
		if (is_file($new_path))
		{
			$cur_path = $cur_dir . "/" . $file_name;

			// ӽ¹
			$result = $this->cmp_files($new_path, $cur_path, $df_result);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN79:
				$this->set_log_msg(IPREV_GEN79, array($file_name));
				return IPREV_GEN79;
			default:
				return IPREV_GEN99;
			}

			// Ƥ˺ۤ $cur_dir ˥ԡ
			if ($df_result == FALSE)
			{
				if (copy($new_path, $cur_path))
				{
//					$this->set_debug_msg(IPREV_GEN78, array($file_name));
					$this->set_log_msg(IPREV_GEN78, array($file_name));
				}
				else
				{
					$this->set_log_msg(IPREV_GEN77, array($file_name));
					return IPREV_GEN77;
				}
			}
		}
		return IPREV_GEN00;
	}


	/**
	 * ؿ̾cmp_files
	 *   ĤΥեӤ
	 * @param  $new_path	եѥ				(i)
	 * @param  $cur_path	եѥ				(i)
	 * @param  $df_result	ӷ					(i/o)
	 *						Ʊ졧TRUE
	 *						ư㤤FALSE$cur_path ¸ߤʤޤ
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN79	diff command 
	 * @desc   "$m_cmd_diff $new_path $cur_path" ޥɤȯԤƥå
	 *         Ƥ˰㤤 $df_line ʸϿ
	 */
	function cmp_files($new_path, $cur_path, &$df_result)
	{
		$df_result = FALSE;
		if (file_exists($cur_path) == FALSE)
		{
			$this->set_debug_msg(IPREV_GEN80, array($cur_path));
			return IPREV_GEN00;
		}

		// ޥɺ
		$cmd_str	= sprintf("%s %s %s", $this->m_cmd_diff, $new_path, $cur_path);

		// ޥȯ
		$cmd_h = popen($cmd_str, "r");
		if ($cmd_h == FALSE)
			return IPREV_GEN79;

		// ӷȽ
		$df_line_cnt = 0;
		while (!feof($cmd_h))
		{
			$df_buf = fgets($cmd_h);
			if ($df_buf != "")
			{
				$df_line_cnt++;
				$this->set_debug_msg(IPREV_GEN81, array($df_buf));
			}
		}

		pclose($cmd_h);

		if ($df_line_cnt > 0)
		{
			return IPREV_GEN00;
		}

		$df_result = TRUE;
		return IPREV_GEN00;
	}

	//-----------------------------------------------------------------------
	// private methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾init_cmd_str
	 *   ޥʸƥѿϿ
	 */
	function init_cmd_str()
	{
		$this->m_cmd_diff = sprintf(
					"%s %s",
					$this->m_iprev_conf->m_conf_data[CMD_DF],
					$this->m_iprev_conf->m_conf_data[CMD_DFOPT]);

		$this->m_cmd_cp_all = $this->m_iprev_conf->m_conf_data[CMD_CPALL];
	}

	/**
	 * ؿ̾close_all_dir
	 *   ꤵ줿ǥ쥯ȥclose
	 * @param $ndh		NEW[ZONE|CONF] ǥ쥯ȥϥɥ
	 * @param $cdh		CUR[ZONE|CONF] ǥ쥯ȥϥɥ
	 */
	function close_all_dir($ndh, $cdh)
	{
		if ($ndh != FALSE)
			closedir($ndh);
		if ($cdh != FALSE)
			closedir($cdh);
	}

	/**
	 * ؿ̾set_log_msg
	 *   åɲä
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_log_msg($msg_id, $options="")
	{
		$this->m_log_msg .= $this->m_iprev_msg[$msg_id];
		if (is_array($options))
		{
			for ($n = 0; $n < count($options); $n++)
			{
				if ($options[$n] !== "")
				{
					if (substr($options[$n], -1) == "\n")
						$this->m_log_msg .= " [" . substr($options[$n], 0, -1) . "]";
					else
						$this->m_log_msg .= " [" . $options[$n] . "]";
				}
			}
		}
	}

	/**
	 * ؿ̾get_log_msg
	 *   å
	 * @return å
	 */
	function get_log_msg()
	{
		return $this->m_log_msg;
	}

	/**
	 * ؿ̾set_debug_msg
	 *   ǥХååɲäm_debug_flag == true Τߡ
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_debug_msg($msg_id, $options)
	{
		if ($this->m_debug_flag)
		{
			$this->m_debug_msg .= $this->m_iprev_msg[$msg_id];
			if (is_array($options))
			{
				for ($n = 0; $n < count($options); $n++)
				{
					if ($options[$n] !== "")
					{
						if (substr($options[$n], -1) == "\n")
							$this->m_debug_msg .= " [" . substr($options[$n], 0, -1) . "]";
						else
							$this->m_debug_msg .= " [" . $options[$n] . "]";
					}
				}
			}
		}
	}

	/**
	 * ؿ̾get_debug_msg
	 *   ǥХååm_debug_flag == true Τߡ
	 * @return ǥХåʸ
	 */
	function get_debug_msg()
	{
		if ($this->m_debug_flag && $this->m_debug_msg != "")
		{
			$this->m_debug_msg =
						"\n\n-------------[update debug msg START]-------------\n" .
						$this->m_debug_msg .
						"\n\n-------------[update debug msg END]-------------\n";
		}
		else
		{
			return "";
		}
		return $this->m_debug_msg;
	}
}
?>
